#!/bin/bash

OUTPUT=./results/desktop/res
BLOCKSIZE=64Ki
OFFSET=1Mi
MAXN=16
AT=10000

for N in `seq 1 $MAXN`;do
	MIN[$N]=-1;
	ALL[$N]=0;
done

#for i in `seq 1 $AT`;do
#	echo -n ".";
#done

#echo -en "\r"
for i in `seq 1 $AT`;do
	for N in `seq 1 $MAXN`;do
		RES=$(./main $BLOCKSIZE $OFFSET $N | awk '{print $4}');
		if [ ${MIN[N]} -eq -1 ] || [ ${MIN[N]} -ge $RES ] ;then
			MIN[$N]=$RES;
		fi;
		ALL[$N]=$((ALL[N]+RES));
	done;
	echo -en "\r$i / $AT"
#	echo -n "#"
done
echo

for N in `seq 1 $MAXN`;do
	echo $N ${MIN[N]} $((ALL[N] / AT));
done > ${OUTPUT}.txt

{
echo	"
	set term svg enhanced size 1024,600

	set object 1 rectangle from graph 0, graph 0 to graph 1, graph 1 behind fc rgbcolor 'white' fs noborder

	set output '${OUTPUT}.svg'
	set xlabel 'N'
	set ylabel 'Такты'

	set title 'Blocksize = $BLOCKSIZE, Offset = $OFFSET, Attempts = $AT'
	set grid
	set xtics 1
	set ytics

	plot '${OUTPUT}.txt' using 1:2 w l title 'Минимальный результат', '${OUTPUT}.txt' using 1:3 w l title 'Средний результат'
	"
}|gnuplot
